<template>
  <section class="section">
    <div class="container">
      <div class="columns is-centered">
        <div class="column is-half">
          <h1 class="title has-text-centered">Add a Service</h1>
          <form class="form" v-on:submit.prevent="registerService">
            <div class="field">
              <label class="label">Name</label>
              <div class="control">
                <input
                  required
                  type="text"
                  class="input"
                  placeholder="My Awesome Service"
                  v-model="service.name"
                />
              </div>
            </div>
            <div class="field">
              <label class="label">Abstract</label>
              <div class="control">
                <textarea
                  required
                  type="textarea"
                  class="textarea"
                  placeholder="Enter a short abstract"
                  v-model="service.abstract"
                />
              </div>
            </div>
            <div class="field">
              <label class="label">Description</label>
              <div class="control">
                <textarea
                  required
                  type="textarea"
                  class="textarea"
                  placeholder="Enter a long description here. Markdown can be used"
                  v-model="service.description"
                />
              </div>
            </div>
            <div class="field">
              <label class="label">Logo URL</label>
              <div class="control">
                <input
                  required
                  type="url"
                  class="input"
                  placeholder="https://example.com/logo.png"
                  v-model="service.graphic"
                />
              </div>
            </div>
            <div class="columns">
              <div class="column is-half">
                <div class="field">
                  <label class="label">License</label>
                  <div class="control">
                    <div class="select">
                      <select name="license" v-model="service.licenseId">
                        <option
                          v-for="license in licenses"
                          :key="license.id"
                          :value="license.id"
                        >{{ license.title }}</option>
                      </select>
                    </div>
                  </div>
                </div>
              </div>
              <div class="column is-half">
                <div class="field">
                  <label class="label">Lifecycle Stage</label>
                  <div class="control">
                    <div class="select">
                      <select name="lifecycle_stage" v-model="service.lifecycleStage">
                        <option v-for="stage in stages" :key="stage" :value="stage">{{ stage }}</option>
                      </select>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <h2 class="title is-4">Pricing</h2>
            <div class="media" v-for="(plan, idx) in service.price_plans" :key="idx">
              <div class="media-content">
                <div class="columns">
                  <div class="column is-5">
                    <div class="field">
                      <label class="label">Title</label>
                      <input
                        required
                        type="text"
                        class="input"
                        placeholder="Free Plan"
                        v-model="plan.displayName"
                      />
                    </div>
                    <div class="field">
                      <label class="checkbox">
                        <input type="checkbox" v-model="plan.free" />Free?
                      </label>
                    </div>
                  </div>
                  <div class="column is-7">
                    <div class="field">
                      <label class="label">Description</label>
                      <textarea
                        required
                        type="textarea"
                        class="textarea"
                        placeholder="Description of price plan"
                        v-model="plan.description"
                      />
                    </div>
                  </div>
                </div>
              </div>
              <div class="media-right">
                <div
                  v-if="idx===service.price_plans.length-1"
                  v-on:click="addPricePlan()"
                  class="button is-success is-small"
                >
                  <span class="icon is-small">
                    <svg
                      role="img"
                      xmlns="http://www.w3.org/2000/svg"
                      width="24px"
                      height="24px"
                      viewBox="0 0 24 24"
                      aria-labelledby="plusIconTitle plusIconDesc"
                      stroke="#fff"
                      stroke-width="1.5"
                      stroke-linecap="square"
                      stroke-linejoin="miter"
                      fill="none"
                      color="#fff"
                    >
                      <title id="plusIconTitle">Add Credentials</title>
                      <desc id="plusIconDesc">Create new credentials</desc>
                      <path d="M20 12L4 12M12 4L12 20" />
                    </svg>
                  </span>
                </div>
                <button v-on:click="removePricePlan(idx)" class="button is-danger is-small" v-else>
                  <a-close-button />
                </button>
              </div>
            </div>
            <h2 class="title is-4">Connection Info</h2>
            <div class="field">
              <label class="label">Upstream URL</label>
              <div class="control">
                <input
                  required
                  type="text"
                  class="input"
                  placeholder="https://your.upstream.service"
                  v-model="service.upstream"
                />
              </div>
            </div>
            <div class="field">
              <label class="checkbox">
                <input
                  type="checkbox"
                  v-model="credentials_required"
                  v-on:change="resetCredentials"
                />
                This service requires authentication
              </label>
            </div>
            <template v-if="credentials_required">
              <div class="column is-half" style="padding-left: unset; padding-right: unset;">
                <div class="field">
                  <label class="label">Upstream Credentials</label>
                  <div class="control">
                    <div class="select">
                      <select name="credentials" v-model="service.credentials_type">
                        <option
                          v-for="cred in credential_types"
                          :value="cred.key"
                          :key="cred.key"
                        >{{ cred.title }}</option>
                      </select>
                    </div>
                  </div>
                </div>
              </div>
              <div v-for="field in selectedCredentials.fields" class="field" :key="field.key">
                <label class="label">{{ field.name }}</label>
                <input class="input" :type="field.type" v-model="service.credentials[field.key]" />
              </div>
            </template>
            <div class="level">
              <div class="level-left">
                <input
                  class="button is-danger is-inverted"
                  type="submit"
                  value="Cancel"
                  v-on:click.prevent="redirect"
                />
              </div>
              <div class="level-right">
                <input
                  class="button is-primary is-outlined"
                  type="submit"
                  value="Save"
                  :disabled="!valid"
                />
              </div>
            </div>
          </form>
        </div>
      </div>
    </div>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import { CatalogItem, emptyCatalogItem } from "@/services/osb/catalog";
import { ArbaloExtensions } from "@/services/arbalo_extensions/service";
import NewArbaloExtensionsService from "@/services/arbalo_extensions/service";
import {
  ServiceRequest,
  PricePlanRequest,
  EmptyPricePlanRequest
} from "@/services/arbalo_extensions/services";
import { MessageLevel } from "../store/types";
import ACloseButton from "@/components/ACloseButton.vue";

@Component({
  components: {
    ACloseButton
  }
})
export default class AddServiceProvider extends Vue {
  private arbaloService: ArbaloExtensions = NewArbaloExtensionsService({
    baseURL: process.env.VUE_APP_OSBAPI_BASE_URL
      ? process.env.VUE_APP_OSBAPI_BASE_URL
      : "default-api-base-url"
  });

  licenses: { id: number; title: string }[] = [
    { id: 1, title: "MIT" },
    { id: 2, title: "Apache License 2.0" },
    { id: 3, title: "GNU General Public License v3" },
    { id: 4, title: "BSD 3-Clause License (Revised)" },
    { id: 5, title: "GNU Lesser General Public License v3 (LGPL-3.0)" },
    { id: 6, title: "GNU General Public License v2.0 (GPL-2.0)" },
    { id: 7, title: "Closed Source" },
    { id: 8, title: "Custom" }
  ];

  stages: string[] = [
    "Planned",
    "Beta",
    "Productive",
    "Decommitted",
    "Archived"
  ];

  // Used for mapping credential types to what we support in the database
  credential_types: {
    key: string;
    title: string;
    description: string;
    fields?: { name: string; key: string; type: string }[];
  }[] = [
    { title: "None", key: "none", description: "" },
    {
      title: "HTTP Basic Auth",
      key: "http basic",
      description: "",
      fields: [
        { name: "Username", key: "username", type: "text" },
        { name: "Password", key: "password", type: "password" }
      ]
    },
    {
      title: "API Key - Query parameter",
      key: "key query",
      description: "",
      fields: [
        { name: "Query parameter key", key: "query_key", type: "text" },
        { name: "API Key", key: "query_api_key", type: "text" }
      ]
    },
    {
      title: "API Key - HTTP Headers",
      key: "key header",
      description: "",
      fields: [
        { name: "HTTP Header Name", key: "header_key", type: "text" },
        { name: "API Key", key: "header_api_key", type: "text" }
      ]
    }
  ];

  name: string = "";
  abstract: string = "";
  description: string = "";
  graphic: string = "";
  lifecycleStage: string = this.stages[0];
  licenseId: number = 1;
  credentials_required: boolean = false;

  service: ServiceRequest = {
    name: "",
    abstract: "",
    description: "",
    graphic: "",
    licenseId: 1,
    lifecycleStage: this.stages[0],
    upstream: "",
    credentials_type: "none",
    credentials: {},
    price_plans: [EmptyPricePlanRequest()]
  };

  get valid(): boolean {
    return (
      this.service.name != "" &&
      this.service.abstract != "" &&
      this.service.description != "" &&
      this.service.graphic != "" &&
      this.service.lifecycleStage != "" &&
      this.service.upstream != ""
    );
  }

  get selectedCredentials() {
    return this.credential_types.find(
      e => e.key === this.service.credentials_type
    );
  }

  resetCredentials() {
    if (!this.credentials_required) {
      this.service.credentials_type = "none";
      this.service.credentials = {};
    }
  }

  async registerService() {
    try {
      await this.arbaloService.insert(this.service);
      this.$store.commit("setMessage", {
        level: MessageLevel.Success,
        header: "Thank you",
        body: "Your service has been added to the Arbalo database"
      });
      // Refresh service catalog and redirect there
      await this.$store.dispatch("catalog/fetchCatalog");
      this.$router.push({ name: "service-catalog" });
    } catch (err) {
      console.error(err);
      this.$store.commit(
        "setErrorMessage",
        "Something went wrong when trying to add your service - Sorry!"
      );
    }
  }

  addPricePlan() {
    this.service.price_plans.push(EmptyPricePlanRequest());
  }

  removePricePlan(index: number) {
    this.service.price_plans.splice(index, 1);
  }

  redirect() {
    this.$router.push({ name: "service-catalog" });
  }
}
</script>

<style lang="scss" scoped>
</style>
